package domaine;

public class ListeChane<T> implements Itrable<T>  {
	private class ElmentDeListe {
		public T contenu;
		public ElmentDeListe suivant;
		public ElmentDeListe prcdent;
		public ElmentDeListe(T lment) {
			contenu = lment;
			suivant = prcdent = null;
		}
	}
	private class IterateurDeListe implements Itrateur<T> {
		private ElmentDeListe courant;
		public IterateurDeListe() {
			courant = premier;
		}
		public boolean lmentPrsent() {
			return courant != null;
		}
		public T lmentCourant() {
			return courant.contenu;
		}
		public void avance() {
			courant = courant.suivant;
		}
	}
	private ElmentDeListe premier, dernier;
	private int nombreDElments;
	public ListeChane() {
		premier = dernier = null;
		nombreDElments = 0;
	}
	public void ajoute(T element) {
		ElmentDeListe nouvelElment = new ElmentDeListe(element);
		if (premier == null) {
			premier = dernier = nouvelElment;
		} else {
			dernier.suivant = nouvelElment;
			nouvelElment.prcdent = dernier;
		}
		dernier = nouvelElment;
		nombreDElments++;
	}
	private void retire(ElmentDeListe courant) {
		if (courant == premier && courant == dernier) {
			premier = dernier = null;
			nombreDElments = 0;
		} else {
			if (courant != premier && courant != dernier) {
				courant.prcdent.suivant = courant.suivant;
				courant.suivant.prcdent = courant.prcdent;
			}
			if (courant == premier) {
				premier = courant.suivant;
				premier.prcdent = null;
			}
			if (courant == dernier) {
				dernier = courant.prcdent;
				dernier.suivant = null;
			}
			nombreDElments--;
		}
		courant.suivant = courant.prcdent = null;
	}
	public void retire(T lment) {
		ElmentDeListe courant = premier;
		while (courant != null && courant.contenu != lment) {
			courant = courant.suivant;
		}
		if (courant != null) retire(courant);
	}
	public void retire(int index) {
		ElmentDeListe courant;
		courant = premier;
		while (courant != null && index > 0) {
			courant = courant.suivant;
			index--;
		}
		retire(courant);
	}
	public int taille() {
		return nombreDElments;
	}
	public T lment(int index) {
		ElmentDeListe courant = premier;
		while (courant != null && index > 0) {
			courant = courant.suivant;
			index--;
		}
		return courant.contenu;
	}
	public boolean estVide() {
		return premier == null;
	}
	public boolean contient(T lment) {
		ElmentDeListe courant = premier;
		while (courant != null && courant.contenu != lment) {
			courant = courant.suivant;
		}
		return (courant != null);
	}
	public Itrateur<T> itrateur() {
		return new IterateurDeListe();
	}
}
